<div class="screenshare-modal">
  <AdvancedModal>
    <!-- This modal is *only* shown on native! -->
    <h2>Screenshare</h2>
    <div class="native-screenshare">
      {#if screens}
      {#each screens as screen}
      <ScreenPreview channelId={modalContext.id}
                     selectedAudio={sharing.includes(screen.id + "_audio")}
                     selectedVideo={sharing.includes(screen.id + "_video")}
                     name={screen.name}
                     on:share="share(screen, event)"
                     thumbnail={screen.thumbnail} />
      {/each}
      {:else}
      Loading, sit tight!
      {/if}
    </div>
  </AdvancedModal>
</div>

<style>
  .native-screenshare {
    overflow: auto;
    max-height: 60vh;
  }
</style>

<script>
  import * as Native from "../../js/Native";
  import {clients} from "../../js/MediaClient";
  
  export default {
    components: {
      AdvancedModal: "./AdvancedModal.svelte",
      ScreenPreview: "../ScreenPreview.svelte"
    },
    data() {
      return {
        screens: [],
        sharing: []
      };
    },
    oncreate() {
      Native.enumerateDisplays().then(screens =>
        this.set({
          screens
        })
      );
      const {modalContext} = this.get();
      this._mediaClient = clients.get(modalContext.channelId);
      this.calculateSharing();
    },
    methods: {
      calculateSharing() {
        console.log("calculateSharing()", this._mediaClient, this);
        this.set({
          sharing: Array.from(this._mediaClient._screenShares.keys())
        });
      },
      async share(screen, type) {
        const stream = await navigator.mediaDevices.getUserMedia({
          [type]: {
            mandatory: {
              chromeMediaSource: "desktop",
              chromeMediaSourceId: screen.id
            }
          }
        });

        const tracks = stream.getTracks();

        for (const track of tracks) {
          console.log(this._mediaClient, this, "addTrack");
          await this._mediaClient.addTrack(track, screen.id + "_" + type);
        }

        this._mediaClient._screenShares.set(screen.id + "_" + type, {
          id: screen.id + "_" + type,
          label: screen.name,
          kind: "screenshare" + type
        });
        this.calculateSharing();
      }
    }
  };
</script>
